from math import *
import random
from esys.lsm.util import Vec3
import sys
sys.setrecursionlimit(100000)

for i in range(10):
	for j in range(100):
		fID = i*100+j
		if (j == 22):
			continue

		M_PI = 3.141592653

		k1_name="blockEnergy"+str(fID)+".geo"  		
		k1_file=open(k1_name,"wb")
		ep = 1272.508274879 # energy density


		M_PI = 3.141592653; rhos = 2650
		sumA = 110638.838066
		f1_name="../../T"+str(i)+"/results/deposit_data_5_"+str(fID)+".txt"
		print f1_name
		fh1=open(f1_name,'r')
		pData = fh1.readlines()
		pDataList = []
		for i0 in range(37022):
			pDataList.append([0.0, 0.0, 0.0])
		for line in pData:
			k=line.split()
			x = float(k[0])
			y = float(k[1])
			z = float(k[2])
			R = float(k[3])
			ID = int(k[4])
			tag = int(k[5])
			m = float(k[6])
			vel = Vec3(float(k[7]), float(k[8]), float(k[9]))
			wvel = Vec3(float(k[13]), float(k[14]), float(k[15]))
			I = 0.4*m*R*R
			Ek = 0.5*(m*vel.norm()*vel.norm()+I*wvel.norm()*wvel.norm())
			pDataList[ID] = [Ek, R, m]

		f0_name="../blocks/blockLists"+str(fID)+".dat" 
		fh0=open(f0_name,'r')	
		PSDList = []
		for line in fh0.readlines():
			k=line.split()
			Area = 0.0; Ek = 0; Msum = 0.0
			for pp in k:
				ID = int(pp)
				r = pDataList[ID][1]
				Area += M_PI*r*r
				Ek += pDataList[ID][0]
				Msum += pDataList[ID][2]
			
			mass = Area*rhos				
			blockSize = sqrt(Area/sumA)
			PSDList.append([Ek/Msum/ep, blockSize])	
		PSDList.sort()
		PSDList.reverse()
		fh0.close()


		for pp in PSDList:
			blockSize = pp[1]
			Ek = pp[0]
			k1_file.write(str(blockSize)+'\t'+str(Ek)+'\n')
